<?php

$rssc = array('title', 'description', array(), 'excerpt');
$options_file = (dirname(__FILE__) . "/combiner.cfg");

define("MAGPIE_DIR", "./magpie/");
define("MAGPIE_CACHE_ON", true);
define("MAGPIE_CACHE_DIR", "./magpie/cache/");
define('MAGPIE_OUTPUT_ENCODING', "UTF-8");

require_once(MAGPIE_DIR."magpierss.inc");
require_once("functions.php");

$rssc = loadConfig($options_file);
$rssfeeds = array();

foreach($rssc[2] as $url_link) {
	$rss1 = fetch_rss($url_link);
	$to_fetch = count($rss1->items);
	$counter=0;
	foreach ($rss1->items as $item) {
		if( $counter < $to_fetch )	{
			$item['unixtime'] = unixTime($item);
			array_push($rssfeeds, $item);
		}
		$counter++;
	}
}

for($k=0;$k<count($rssfeeds);$k++) {
	for($j=$k;$j<count($rssfeeds);$j++) {
		if( $rssfeeds[$k]['unixtime'] < $rssfeeds[$j]['unixtime'] ) {
				$swapper=$rssfeeds[$j];
				$rssfeeds[$j]=$rssfeeds[$k];
				$rssfeeds[$k]=$swapper;
		}
	}
}

header("Content-type: text/xml; charset=UTF-8" , true);
$output = '<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0">
<channel>
	<title>' . $rssc['title'] . '</title>
	<link>http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . '</link>
	<description>' . $rssc['description'] . '</description>
	<language>en</language>
	';
	
$output .= "<lastBuildDate>".gmdate('D, d M Y H:i:s', time()) . " GMT" . "</lastBuildDate>\n";

for($i=0; $i < $rssc['items']; $i++) {

	if ( count($rssfeeds) == $i ) break;
	
	if ($rssfeeds[$i][description]) { $content = $rssfeeds[$i][description]; }
	if ($rssfeeds[$i][content][encoded]) { $content = $rssfeeds[$i][content][encoded]; }
	if ($rssfeeds[$i][atom_content]) { $content = $rssfeeds[$i][atom_content]; }
	if ( $rssc['excerpt'] ) { $content = trimExcerpt($content); }
	
	$pubdate = date("r", $rssfeeds[$i][unixtime]);

	$output .= "\n		<item>\n";
	$output .= "		<title><![CDATA[".$rssfeeds[$i][title]."]]></title>\n";
	$output .= "		<link>".$rssfeeds[$i][link]."</link>\n";
	$output .= "		<guid>".$rssfeeds[$i][link]."</guid>\n";
	$output .= "		<pubDate>".$pubdate."</pubDate>\n";
	$output .= "		<description><![CDATA[\n".$content."\n		]]></description>\n";
	$output .= "		</item>\n";

}
$output .= "</channel>\n\n</rss>";
echo $output;

?>
